Index: kernel/genarch/src/acpi/acpi.c
===================================================================
--- kernel/genarch/src/acpi/acpi.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/acpi/acpi.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -39,6 +39,6 @@
 #include <genarch/acpi/madt.h>
 #include <arch/bios/bios.h>
-#include <mm/as.h>
 #include <mm/page.h>
+#include <mm/km.h>
 #include <print.h>
 
@@ -96,11 +96,20 @@
 }
 
-static void map_sdt(struct acpi_sdt_header *sdt)
-{
-	page_table_lock(AS_KERNEL, true);
-	page_mapping_insert(AS_KERNEL, (uintptr_t) sdt, (uintptr_t) sdt,
-	    PAGE_NOT_CACHEABLE | PAGE_WRITE);
-	map_structure((uintptr_t) sdt, sdt->length);
-	page_table_unlock(AS_KERNEL, true);
+static struct acpi_sdt_header *map_sdt(struct acpi_sdt_header *psdt)
+{
+	struct acpi_sdt_header *vhdr;
+	struct acpi_sdt_header *vsdt;
+
+	/* Start with mapping the header only. */
+	vhdr = (struct acpi_sdt_header *) km_map((uintptr_t) psdt,
+	    sizeof(struct acpi_sdt_header), PAGE_READ | PAGE_NOT_CACHEABLE); 
+
+	/* Now we can map the entire structure. */
+	vsdt = (struct acpi_sdt_header *) km_map((uintptr_t) psdt,
+	    vhdr->length, PAGE_WRITE | PAGE_NOT_CACHEABLE);
+	
+	// TODO: do not leak vtmp
+
+	return vsdt; 
 }
 
@@ -118,10 +127,10 @@
 			    (struct acpi_sdt_header *) (sysarg_t) acpi_rsdt->entry[i];
 			
-			map_sdt(hdr);
-			if (CMP_SIGNATURE(hdr->signature, signature_map[j].signature)) {
-				if (!acpi_sdt_check((uint8_t *) hdr))
+			struct acpi_sdt_header *vhdr = map_sdt(hdr);
+			if (CMP_SIGNATURE(vhdr->signature, signature_map[j].signature)) {
+				if (!acpi_sdt_check((uint8_t *) vhdr))
 					break;
 				
-				*signature_map[j].sdt_ptr = hdr;
+				*signature_map[j].sdt_ptr = vhdr;
 				LOG("%p: ACPI %s", *signature_map[j].sdt_ptr,
 				    signature_map[j].description);
@@ -144,10 +153,10 @@
 			    (struct acpi_sdt_header *) ((uintptr_t) acpi_xsdt->entry[i]);
 			
-			map_sdt(hdr);
-			if (CMP_SIGNATURE(hdr->signature, signature_map[j].signature)) {
-				if (!acpi_sdt_check((uint8_t *) hdr))
+			struct acpi_sdt_header *vhdr = map_sdt(hdr);
+			if (CMP_SIGNATURE(vhdr->signature, signature_map[j].signature)) {
+				if (!acpi_sdt_check((uint8_t *) vhdr))
 					break;
 				
-				*signature_map[j].sdt_ptr = hdr;
+				*signature_map[j].sdt_ptr = vhdr;
 				LOG("%p: ACPI %s", *signature_map[j].sdt_ptr,
 				    signature_map[j].description);
@@ -187,13 +196,17 @@
 	LOG("%p: ACPI Root System Description Pointer", acpi_rsdp);
 	
-	acpi_rsdt = (struct acpi_rsdt *) ((uintptr_t) acpi_rsdp->rsdt_address);
+	uintptr_t acpi_rsdt_p = (uintptr_t) acpi_rsdp->rsdt_address;
+	uintptr_t acpi_xsdt_p = 0;
+
 	if (acpi_rsdp->revision)
-		acpi_xsdt = (struct acpi_xsdt *) ((uintptr_t) acpi_rsdp->xsdt_address);
-	
-	if (acpi_rsdt)
-		map_sdt((struct acpi_sdt_header *) acpi_rsdt);
-	
-	if (acpi_xsdt)
-		map_sdt((struct acpi_sdt_header *) acpi_xsdt);
+		acpi_xsdt_p = (uintptr_t) acpi_rsdp->xsdt_address;
+	
+	if (acpi_rsdt_p)
+		acpi_rsdt = (struct acpi_rsdt *) map_sdt(
+		    (struct acpi_sdt_header *) acpi_rsdt_p);
+	
+	if (acpi_xsdt_p)
+		acpi_xsdt = (struct acpi_xsdt *) map_sdt(
+		    (struct acpi_sdt_header *) acpi_xsdt_p);
 	
 	if ((acpi_rsdt) && (!acpi_sdt_check((uint8_t *) acpi_rsdt))) {
Index: kernel/genarch/src/drivers/ega/ega.c
===================================================================
--- kernel/genarch/src/drivers/ega/ega.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/drivers/ega/ega.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -37,8 +37,7 @@
 #include <genarch/drivers/ega/ega.h>
 #include <putchar.h>
-#include <mm/page.h>
+#include <mm/km.h>
 #include <mm/as.h>
 #include <mm/slab.h>
-#include <arch/mm/page.h>
 #include <typedefs.h>
 #include <arch/asm.h>
@@ -598,5 +597,6 @@
 	
 	instance->base = base;
-	instance->addr = (uint8_t *) hw_map(addr, EGA_VRAM_SIZE);
+	instance->addr = (uint8_t *) km_map(addr, EGA_VRAM_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	if (!instance->addr) {
 		LOG("Unable to EGA video memory.");
Index: kernel/genarch/src/drivers/i8042/i8042.c
===================================================================
--- kernel/genarch/src/drivers/i8042/i8042.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/drivers/i8042/i8042.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -44,4 +44,5 @@
 #include <mm/slab.h>
 #include <ddi/device.h>
+#include <time/delay.h>
 
 #define i8042_SET_COMMAND  0x60
@@ -51,4 +52,6 @@
 #define i8042_BUFFER_FULL_MASK  0x01
 #define i8042_WAIT_MASK         0x02
+
+#define i8042_TIMEOUT  65536
 
 static irq_ownership_t i8042_claim(irq_t *irq)
@@ -77,6 +80,24 @@
 static void i8042_clear_buffer(i8042_t *dev)
 {
-	while (pio_read_8(&dev->status) & i8042_BUFFER_FULL_MASK)
+	for (uint32_t i = 0; i < i8042_TIMEOUT; i++) {
+		if ((pio_read_8(&dev->status) & i8042_BUFFER_FULL_MASK) == 0)
+			break;
+		
 		(void) pio_read_8(&dev->data);
+		delay(50);  /* 50 us think time */
+	}
+}
+
+static void i8042_send_command(i8042_t *dev, uint8_t cmd)
+{
+	for (uint32_t i = 0; i < i8042_TIMEOUT; i++) {
+		if ((pio_read_8(&dev->status) & i8042_WAIT_MASK) == 0)
+			break;
+		
+		delay(50);  /* 50 us think time */
+	}
+	
+	pio_write_8(&dev->status, cmd);
+	delay(10000);  /* 10 ms think time */
 }
 
@@ -84,6 +105,6 @@
 i8042_instance_t *i8042_init(i8042_t *dev, inr_t inr)
 {
-	i8042_instance_t *instance
-	    = malloc(sizeof(i8042_instance_t), FRAME_ATOMIC);
+	i8042_instance_t *instance =
+	    malloc(sizeof(i8042_instance_t), FRAME_ATOMIC);
 	if (instance) {
 		instance->i8042 = dev;
@@ -96,5 +117,4 @@
 		instance->irq.handler = i8042_irq_handler;
 		instance->irq.instance = instance;
-		
 	}
 	
@@ -107,7 +127,8 @@
 	ASSERT(kbrdin);
 	
+	i8042_clear_buffer(instance->i8042);
+	
 	instance->kbrdin = kbrdin;
 	irq_register(&instance->irq);
-	i8042_clear_buffer(instance->i8042);
 }
 
@@ -116,9 +137,6 @@
 {
 	interrupts_disable();
-	
 	i8042_clear_buffer(dev);
-	
-	/* Reset CPU */
-	pio_write_8(&dev->status, i8042_CPU_RESET);
+	i8042_send_command(dev, i8042_CPU_RESET);
 }
 
Index: kernel/genarch/src/drivers/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- kernel/genarch/src/drivers/s3c24xx_uart/s3c24xx_uart.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/drivers/s3c24xx_uart/s3c24xx_uart.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -45,4 +45,5 @@
 #include <mm/slab.h>
 #include <mm/page.h>
+#include <mm/km.h>
 #include <sysinfo/sysinfo.h>
 #include <str.h>
@@ -113,5 +114,6 @@
 	uart_dev->data = uart;
 
-	uart->io = (s3c24xx_uart_io_t *) hw_map(paddr, PAGE_SIZE);
+	uart->io = (s3c24xx_uart_io_t *) km_map(paddr, PAGE_SIZE,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	uart->indev = NULL;
 
Index: kernel/genarch/src/fb/bfb.c
===================================================================
--- kernel/genarch/src/fb/bfb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/fb/bfb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -40,5 +40,5 @@
 #include <console/console.h>
 
-uintptr_t bfb_addr = (uintptr_t) -1;
+uintptr_t bfb_addr = 0;
 uint32_t bfb_width = 0;
 uint32_t bfb_height = 0;
@@ -57,5 +57,6 @@
 bool bfb_init(void)
 {
-	if ((bfb_width == 0) || (bfb_height == 0))
+	if ((bfb_addr == 0) || (bfb_width == 0) || (bfb_height == 0) ||
+	    (bfb_bpp == 0) || (bfb_scanline == 0))
 		return false;
 	
Index: kernel/genarch/src/fb/fb.c
===================================================================
--- kernel/genarch/src/fb/fb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/fb/fb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -40,5 +40,5 @@
 #include <console/console.h>
 #include <sysinfo/sysinfo.h>
-#include <mm/page.h>
+#include <mm/km.h>
 #include <mm/slab.h>
 #include <align.h>
@@ -587,5 +587,6 @@
 	size_t glyphsize = FONT_GLYPHS * instance->glyphbytes;
 	
-	instance->addr = (uint8_t *) hw_map((uintptr_t) props->addr, fbsize);
+	instance->addr = (uint8_t *) km_map((uintptr_t) props->addr, fbsize,
+	    PAGE_WRITE | PAGE_NOT_CACHEABLE);
 	if (!instance->addr) {
 		LOG("Unable to map framebuffer.");
Index: kernel/genarch/src/mm/as_ht.c
===================================================================
--- kernel/genarch/src/mm/as_ht.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/mm/as_ht.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -41,4 +41,5 @@
 #include <mm/as.h>
 #include <mm/frame.h>
+#include <mm/slab.h>
 #include <typedefs.h>
 #include <memstr.h>
@@ -77,4 +78,6 @@
 		hash_table_create(&page_ht, PAGE_HT_ENTRIES, 2, &ht_operations);
 		mutex_initialize(&page_ht_lock, MUTEX_PASSIVE);
+		pte_cache = slab_cache_create("pte_cache", sizeof(pte_t), 0, NULL, NULL,
+		    SLAB_CACHE_MAGDEFERRED);
 	}
 	
Index: kernel/genarch/src/mm/as_pt.c
===================================================================
--- kernel/genarch/src/mm/as_pt.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/mm/as_pt.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -73,5 +73,6 @@
 pte_t *ptl0_create(unsigned int flags)
 {
-	pte_t *dst_ptl0 = (pte_t *) frame_alloc(PTL0_SIZE, FRAME_KA);
+	pte_t *dst_ptl0 = (pte_t *) frame_alloc(PTL0_SIZE,
+	    FRAME_LOWMEM | FRAME_KA);
 	size_t table_size = FRAME_SIZE << PTL0_SIZE;
 	
@@ -89,8 +90,8 @@
 		    (pte_t *) PA2KA((uintptr_t) AS_KERNEL->genarch.page_table);
 		
-		uintptr_t src =
-		    (uintptr_t) &src_ptl0[PTL0_INDEX(KERNEL_ADDRESS_SPACE_START)];
-		uintptr_t dst =
-		    (uintptr_t) &dst_ptl0[PTL0_INDEX(KERNEL_ADDRESS_SPACE_START)];
+		uintptr_t src = (uintptr_t)
+		    &src_ptl0[PTL0_INDEX(KERNEL_ADDRESS_SPACE_START)];
+		uintptr_t dst = (uintptr_t)
+		    &dst_ptl0[PTL0_INDEX(KERNEL_ADDRESS_SPACE_START)];
 		
 		memsetb(dst_ptl0, table_size, 0);
Index: kernel/genarch/src/mm/page_ht.c
===================================================================
--- kernel/genarch/src/mm/page_ht.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/mm/page_ht.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -59,4 +59,7 @@
 static void ht_mapping_remove(as_t *, uintptr_t);
 static pte_t *ht_mapping_find(as_t *, uintptr_t, bool);
+static void ht_mapping_make_global(uintptr_t, size_t);
+
+slab_cache_t *pte_cache = NULL;
 
 /**
@@ -86,5 +89,6 @@
 	.mapping_insert = ht_mapping_insert,
 	.mapping_remove = ht_mapping_remove,
-	.mapping_find = ht_mapping_find
+	.mapping_find = ht_mapping_find,
+	.mapping_make_global = ht_mapping_make_global
 };
 
@@ -163,5 +167,5 @@
 	pte_t *pte = hash_table_get_instance(item, pte_t, link);
 	
-	free(pte);
+	slab_free(pte_cache, pte);
 }
 
@@ -188,5 +192,5 @@
 	
 	if (!hash_table_find(&page_ht, key)) {
-		pte_t *pte = (pte_t *) malloc(sizeof(pte_t), FRAME_ATOMIC);
+		pte_t *pte = slab_alloc(pte_cache, FRAME_LOWMEM | FRAME_ATOMIC);
 		ASSERT(pte != NULL);
 		
@@ -260,4 +264,9 @@
 }
 
+void ht_mapping_make_global(uintptr_t base, size_t size)
+{
+	/* nothing to do */
+}
+
 /** @}
  */
Index: kernel/genarch/src/mm/page_pt.c
===================================================================
--- kernel/genarch/src/mm/page_pt.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/mm/page_pt.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -39,4 +39,5 @@
 #include <mm/page.h>
 #include <mm/frame.h>
+#include <mm/km.h>
 #include <mm/as.h>
 #include <arch/mm/page.h>
@@ -45,13 +46,17 @@
 #include <arch/asm.h>
 #include <memstr.h>
+#include <align.h>
+#include <macros.h>
 
 static void pt_mapping_insert(as_t *, uintptr_t, uintptr_t, unsigned int);
 static void pt_mapping_remove(as_t *, uintptr_t);
 static pte_t *pt_mapping_find(as_t *, uintptr_t, bool);
+static void pt_mapping_make_global(uintptr_t, size_t);
 
 page_mapping_operations_t pt_mapping_operations = {
 	.mapping_insert = pt_mapping_insert,
 	.mapping_remove = pt_mapping_remove,
-	.mapping_find = pt_mapping_find
+	.mapping_find = pt_mapping_find,
+	.mapping_make_global = pt_mapping_make_global
 };
 
@@ -75,8 +80,11 @@
 	
 	if (GET_PTL1_FLAGS(ptl0, PTL0_INDEX(page)) & PAGE_NOT_PRESENT) {
-		pte_t *newpt = (pte_t *) frame_alloc(PTL1_SIZE, FRAME_KA);
+		pte_t *newpt = (pte_t *) frame_alloc(PTL1_SIZE,
+		    FRAME_LOWMEM | FRAME_KA);
 		memsetb(newpt, FRAME_SIZE << PTL1_SIZE, 0);
 		SET_PTL1_ADDRESS(ptl0, PTL0_INDEX(page), KA2PA(newpt));
-		SET_PTL1_FLAGS(ptl0, PTL0_INDEX(page), PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE | PAGE_WRITE);
+		SET_PTL1_FLAGS(ptl0, PTL0_INDEX(page),
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_WRITE);
 	}
 	
@@ -84,8 +92,11 @@
 	
 	if (GET_PTL2_FLAGS(ptl1, PTL1_INDEX(page)) & PAGE_NOT_PRESENT) {
-		pte_t *newpt = (pte_t *) frame_alloc(PTL2_SIZE, FRAME_KA);
+		pte_t *newpt = (pte_t *) frame_alloc(PTL2_SIZE,
+		    FRAME_LOWMEM | FRAME_KA);
 		memsetb(newpt, FRAME_SIZE << PTL2_SIZE, 0);
 		SET_PTL2_ADDRESS(ptl1, PTL1_INDEX(page), KA2PA(newpt));
-		SET_PTL2_FLAGS(ptl1, PTL1_INDEX(page), PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE | PAGE_WRITE);
+		SET_PTL2_FLAGS(ptl1, PTL1_INDEX(page),
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_WRITE);
 	}
 	
@@ -93,8 +104,11 @@
 	
 	if (GET_PTL3_FLAGS(ptl2, PTL2_INDEX(page)) & PAGE_NOT_PRESENT) {
-		pte_t *newpt = (pte_t *) frame_alloc(PTL3_SIZE, FRAME_KA);
+		pte_t *newpt = (pte_t *) frame_alloc(PTL3_SIZE,
+		    FRAME_LOWMEM | FRAME_KA);
 		memsetb(newpt, FRAME_SIZE << PTL3_SIZE, 0);
 		SET_PTL3_ADDRESS(ptl2, PTL2_INDEX(page), KA2PA(newpt));
-		SET_PTL3_FLAGS(ptl2, PTL2_INDEX(page), PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE | PAGE_WRITE);
+		SET_PTL3_FLAGS(ptl2, PTL2_INDEX(page),
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_WRITE);
 	}
 	
@@ -123,5 +137,4 @@
 	/*
 	 * First, remove the mapping, if it exists.
-	 *
 	 */
 	
@@ -140,10 +153,13 @@
 	pte_t *ptl3 = (pte_t *) PA2KA(GET_PTL3_ADDRESS(ptl2, PTL2_INDEX(page)));
 	
-	/* Destroy the mapping. Setting to PAGE_NOT_PRESENT is not sufficient. */
+	/*
+	 * Destroy the mapping.
+	 * Setting to PAGE_NOT_PRESENT is not sufficient.
+	 */
 	memsetb(&ptl3[PTL3_INDEX(page)], sizeof(pte_t), 0);
 	
 	/*
-	 * Second, free all empty tables along the way from PTL3 down to PTL0.
-	 *
+	 * Second, free all empty tables along the way from PTL3 down to PTL0
+	 * except those needed for sharing the kernel non-identity mappings.
 	 */
 	
@@ -162,8 +178,7 @@
 		/*
 		 * PTL3 is empty.
-		 * Release the frame and remove PTL3 pointer from preceding table.
-		 *
-		 */
-		frame_free(KA2PA((uintptr_t) ptl3));
+		 * Release the frame and remove PTL3 pointer from the parent
+		 * table.
+		 */
 #if (PTL2_ENTRIES != 0)
 		memsetb(&ptl2[PTL2_INDEX(page)], sizeof(pte_t), 0);
@@ -171,6 +186,10 @@
 		memsetb(&ptl1[PTL1_INDEX(page)], sizeof(pte_t), 0);
 #else
+		if (km_is_non_identity(page))
+			return;
+
 		memsetb(&ptl0[PTL0_INDEX(page)], sizeof(pte_t), 0);
 #endif
+		frame_free(KA2PA((uintptr_t) ptl3));
 	} else {
 		/*
@@ -195,13 +214,16 @@
 		/*
 		 * PTL2 is empty.
-		 * Release the frame and remove PTL2 pointer from preceding table.
-		 *
-		 */
-		frame_free(KA2PA((uintptr_t) ptl2));
+		 * Release the frame and remove PTL2 pointer from the parent
+		 * table.
+		 */
 #if (PTL1_ENTRIES != 0)
 		memsetb(&ptl1[PTL1_INDEX(page)], sizeof(pte_t), 0);
 #else
+		if (km_is_non_identity(page))
+			return;
+
 		memsetb(&ptl0[PTL0_INDEX(page)], sizeof(pte_t), 0);
 #endif
+		frame_free(KA2PA((uintptr_t) ptl2));
 	} else {
 		/*
@@ -227,9 +249,12 @@
 		/*
 		 * PTL1 is empty.
-		 * Release the frame and remove PTL1 pointer from preceding table.
-		 *
-		 */
+		 * Release the frame and remove PTL1 pointer from the parent
+		 * table.
+		 */
+		if (km_is_non_identity(page))
+			return;
+
+		memsetb(&ptl0[PTL0_INDEX(page)], sizeof(pte_t), 0);
 		frame_free(KA2PA((uintptr_t) ptl1));
-		memsetb(&ptl0[PTL0_INDEX(page)], sizeof(pte_t), 0);
 	}
 #endif /* PTL1_ENTRIES != 0 */
@@ -267,4 +292,49 @@
 }
 
+/** Make the mappings in the given range global accross all address spaces.
+ *
+ * All PTL0 entries in the given range will be mapped to a next level page
+ * table. The next level page table will be allocated and cleared.
+ *
+ * pt_mapping_remove() will never deallocate these page tables even when there
+ * are no PTEs in them.
+ *
+ * @param as   Address space.
+ * @param base Base address corresponding to the first PTL0 entry that will be
+ *             altered by this function.
+ * @param size Size in bytes defining the range of PTL0 entries that will be
+ *             altered by this function.
+ */
+void pt_mapping_make_global(uintptr_t base, size_t size)
+{
+	uintptr_t ptl0 = PA2KA((uintptr_t) AS_KERNEL->genarch.page_table);
+	uintptr_t ptl0step = (((uintptr_t) -1) / PTL0_ENTRIES) + 1;
+	size_t order;
+	uintptr_t addr;
+
+#if (PTL1_ENTRIES != 0)
+	order = PTL1_SIZE;
+#elif (PTL2_ENTRIES != 0)
+	order = PTL2_SIZE;
+#else
+	order = PTL3_SIZE;
+#endif
+
+	ASSERT(ispwr2(ptl0step));
+	ASSERT(size > 0);
+
+	for (addr = ALIGN_DOWN(base, ptl0step); addr - 1 < base + size - 1;
+	    addr += ptl0step) {
+		uintptr_t l1;
+
+		l1 = (uintptr_t) frame_alloc(order, FRAME_KA | FRAME_LOWMEM);
+		memsetb((void *) l1, FRAME_SIZE << order, 0);
+		SET_PTL1_ADDRESS(ptl0, PTL0_INDEX(addr), KA2PA(l1));
+		SET_PTL1_FLAGS(ptl0, PTL0_INDEX(addr),
+		    PAGE_PRESENT | PAGE_USER | PAGE_EXEC | PAGE_CACHEABLE |
+		    PAGE_WRITE);
+	}
+}
+
 /** @}
  */
Index: kernel/genarch/src/multiboot/multiboot.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/multiboot/multiboot.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -77,5 +77,5 @@
 			break;
 		
-		init.tasks[init.cnt].addr = PA2KA(mods[i].start);
+		init.tasks[init.cnt].paddr = mods[i].start;
 		init.tasks[init.cnt].size = mods[i].end - mods[i].start;
 		
Index: kernel/genarch/src/multiboot/multiboot2.c
===================================================================
--- kernel/genarch/src/multiboot/multiboot2.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/genarch/src/multiboot/multiboot2.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -45,5 +45,5 @@
 {
 	if (init.cnt < CONFIG_INIT_TASKS) {
-		init.tasks[init.cnt].addr = PA2KA(module->start);
+		init.tasks[init.cnt].paddr = module->start;
 		init.tasks[init.cnt].size = module->end - module->start;
 		multiboot_extract_command(init.tasks[init.cnt].name,
@@ -76,4 +76,5 @@
 static void multiboot2_fbinfo(const multiboot2_fbinfo_t *fbinfo)
 {
+#ifdef CONFIG_FB
 	if (fbinfo->visual == MULTIBOOT2_VISUAL_RGB) {
 		bfb_addr = fbinfo->addr;
@@ -92,4 +93,5 @@
 		bfb_blue_size = fbinfo->rgb.blue_size;
 	}
+#endif
 }
 
Index: kernel/generic/include/align.h
===================================================================
--- kernel/generic/include/align.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/align.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -42,5 +42,5 @@
  *
  * @param s Address or size to be aligned.
- * @param a Size of alignment, must be power of 2.
+ * @param a Size of alignment, must be a power of 2.
  */
 #define ALIGN_DOWN(s, a)  ((s) & ~((a) - 1))
@@ -50,7 +50,14 @@
  *
  * @param s Address or size to be aligned.
- * @param a Size of alignment, must be power of 2.
+ * @param a Size of alignment, must be a power of 2.
  */
 #define ALIGN_UP(s, a)  (((s) + ((a) - 1)) & ~((a) - 1))
+
+/** Check alignment.
+ *
+ * @param s Address or size to be checked for alignment.
+ * @param a Size of alignment, must be a power of 2.
+ */ 
+#define IS_ALIGNED(s, a)	(ALIGN_UP((s), (a)) == (s))
 
 #endif
Index: kernel/generic/include/config.h
===================================================================
--- kernel/generic/include/config.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/config.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -53,5 +53,5 @@
 
 typedef struct {
-	uintptr_t addr;
+	uintptr_t paddr;
 	size_t size;
 	char name[CONFIG_TASK_NAME_BUFLEN];
@@ -74,12 +74,28 @@
 
 typedef struct {
-	unsigned int cpu_count;      /**< Number of processors detected. */
-	volatile size_t cpu_active;  /**< Number of processors that are up and running. */
+	/** Number of processors detected. */
+	unsigned int cpu_count;
+	/** Number of processors that are up and running. */
+	volatile size_t cpu_active;
 	
 	uintptr_t base;
-	size_t kernel_size;          /**< Size of memory in bytes taken by kernel and stack */
+	/** Size of memory in bytes taken by kernel and stack. */
+	size_t kernel_size;
 	
-	uintptr_t stack_base;        /**< Base adddress of initial stack */
-	size_t stack_size;           /**< Size of initial stack */
+	/** Base adddress of initial stack. */
+	uintptr_t stack_base;
+	/** Size of initial stack. */
+	size_t stack_size;
+
+	bool identity_configured;
+	/** Base address of the kernel identity mapped memory. */
+	uintptr_t identity_base;
+	/** Size of the kernel identity mapped memory. */
+	size_t identity_size;
+
+	bool non_identity_configured;   
+
+	/** End of physical memory. */
+	uint64_t physmem_end;
 } config_t;
 
Index: kernel/generic/include/ddi/ddi.h
===================================================================
--- kernel/generic/include/ddi/ddi.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/ddi/ddi.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -55,6 +55,14 @@
 extern void ddi_parea_register(parea_t *);
 
-extern sysarg_t sys_physmem_map(sysarg_t, sysarg_t, sysarg_t, sysarg_t);
+extern sysarg_t sys_physmem_map(uintptr_t, size_t, unsigned int, void *,
+    uintptr_t);
+extern sysarg_t sys_physmem_unmap(uintptr_t);
+
+extern sysarg_t sys_dmamem_map(size_t, unsigned int, unsigned int, void *,
+    void *, uintptr_t);
+extern sysarg_t sys_dmamem_unmap(uintptr_t, size_t, unsigned int);
+
 extern sysarg_t sys_iospace_enable(ddi_ioarg_t *);
+extern sysarg_t sys_iospace_disable(ddi_ioarg_t *);
 
 /*
Index: kernel/generic/include/ipc/sysipc.h
===================================================================
--- kernel/generic/include/ipc/sysipc.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/ipc/sysipc.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -56,6 +56,6 @@
     unsigned int);
 extern sysarg_t sys_ipc_hangup(sysarg_t);
-extern sysarg_t sys_register_irq(inr_t, devno_t, sysarg_t, irq_code_t *);
-extern sysarg_t sys_unregister_irq(inr_t, devno_t);
+extern sysarg_t sys_irq_register(inr_t, devno_t, sysarg_t, irq_code_t *);
+extern sysarg_t sys_irq_unregister(inr_t, devno_t);
 
 #ifdef __32_BITS__
Index: kernel/generic/include/lib/ra.h
===================================================================
--- kernel/generic/include/lib/ra.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ kernel/generic/include/lib/ra.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,88 @@
+/*
+ * Copyright (c) 2011 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup generic
+ * @{
+ */
+/** @file
+ */
+
+#ifndef KERN_RA_H_
+#define KERN_RA_H_
+
+#include <typedefs.h>
+#include <adt/list.h>
+#include <adt/hash_table.h>
+#include <synch/spinlock.h>
+
+typedef struct {
+	SPINLOCK_DECLARE(lock);
+	list_t spans;		/**< List of arena's spans. */
+} ra_arena_t;
+
+typedef struct {
+	link_t span_link;	/**< Arena's list of spans link. */
+
+	list_t segments;	/**< List of span's segments. */
+
+	size_t max_order;	/**< Base 2 logarithm of span's size. */
+	list_t *free;		/**< max_order segment free lists. */
+
+	hash_table_t used;
+
+	uintptr_t base;		/**< Span base. */
+	size_t size;		/**< Span size. */
+} ra_span_t;
+
+#define RA_SEGMENT_FREE		1
+
+/*
+ * We would like to achieve a good ratio of the size of one unit of the
+ * represented resource (e.g. a page) and sizeof(ra_segment_t).  We therefore
+ * attempt to have as few redundant information in the segment as possible. For
+ * example, the size of the segment needs to be calculated from the segment
+ * base and the base of the following segment.
+ */
+typedef struct {
+	link_t segment_link;	/**< Span's segment list link. */
+	link_t fu_link;		/**< Span's free list or used hash link. */
+
+	uintptr_t base;		/**< Segment base. */
+	uint8_t flags;		/**< Segment flags. */
+} ra_segment_t;
+
+extern void ra_init(void);
+extern ra_arena_t *ra_arena_create(void);
+extern bool ra_span_add(ra_arena_t *, uintptr_t, size_t);
+extern uintptr_t ra_alloc(ra_arena_t *, size_t, size_t);
+extern void ra_free(ra_arena_t *, uintptr_t, size_t);
+
+#endif
+
+/** @}
+ */
Index: kernel/generic/include/macros.h
===================================================================
--- kernel/generic/include/macros.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/macros.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -77,4 +77,6 @@
 #endif /* __ASM__ */
 
+#define ispwr2(x)	(((x) & ((x) - 1)) == 0)
+
 #define isdigit(d)     (((d) >= '0') && ((d) <= '9'))
 #define islower(c)     (((c) >= 'a') && ((c) <= 'z'))
Index: kernel/generic/include/mm/as.h
===================================================================
--- kernel/generic/include/mm/as.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/mm/as.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -242,10 +242,10 @@
 extern int as_page_fault(uintptr_t, pf_access_t, istate_t *);
 
-extern as_area_t *as_area_create(as_t *, unsigned int, size_t, uintptr_t,
-    unsigned int, mem_backend_t *, mem_backend_data_t *);
+extern as_area_t *as_area_create(as_t *, unsigned int, size_t, unsigned int,
+    mem_backend_t *, mem_backend_data_t *, uintptr_t *, uintptr_t);
 extern int as_area_destroy(as_t *, uintptr_t);
 extern int as_area_resize(as_t *, uintptr_t, size_t, unsigned int);
-extern int as_area_share(as_t *, uintptr_t, size_t, as_t *, uintptr_t,
-    unsigned int);
+extern int as_area_share(as_t *, uintptr_t, size_t, as_t *, unsigned int,
+    uintptr_t *, uintptr_t);
 extern int as_area_change_flags(as_t *, unsigned int, uintptr_t);
 
@@ -284,9 +284,8 @@
 
 /* Address space area related syscalls. */
-extern sysarg_t sys_as_area_create(uintptr_t, size_t, unsigned int);
+extern sysarg_t sys_as_area_create(uintptr_t, size_t, unsigned int, uintptr_t);
 extern sysarg_t sys_as_area_resize(uintptr_t, size_t, unsigned int);
 extern sysarg_t sys_as_area_change_flags(uintptr_t, unsigned int);
 extern sysarg_t sys_as_area_destroy(uintptr_t);
-extern sysarg_t sys_as_get_unmapped_area(uintptr_t, size_t);
 
 /* Introspection functions. */
Index: kernel/generic/include/mm/frame.h
===================================================================
--- kernel/generic/include/mm/frame.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ kernel/generic/include/mm/frame.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -50,4 +50,5 @@
 typedef uint8_t frame_flags_t;
 
+#define FRAME_NONE        0x0
 /** Convert the frame address to kernel VA. */
 #define FRAME_KA          0x1
@@ -58,24 +59,42 @@
 /** Do not reserve / unreserve memory. */
 #define FRAME_NO_RESERVE  0x8
+/** Allocate a frame which can be identity-mapped. */
+#define FRAME_LOWMEM	  0x10
+/** Allocate a frame which cannot be identity-mapped. */
+#define FRAME_HIGHMEM	  0x20
 
 typedef uint8_t zone_flags_t;
 
+#define ZONE_NONE	0x0
 /** Available zone (free for allocation) */
-#define ZONE_AVAILABLE  0x0
+#define ZONE_AVAILABLE  0x1
 /** Zone is reserved (not available for allocation) */
-#define ZONE_RESERVED   0x8
+#define ZONE_RESERVED   0x2
 /** Zone is used by firmware (not available for allocation) */
-#define ZONE_FIRMWARE   0x10
+#define ZONE_FIRMWARE   0x4
+/** Zone contains memory that can be identity-mapped */
+#define ZONE_LOWMEM	0x8
+/** Zone contains memory that cannot be identity-mapped */
+#define ZONE_HIGHMEM	0x10
 
-/** Currently there is no equivalent zone flags
-    for frame flags */
-#define FRAME_TO_ZONE_FLAGS(frame_flags)  0
+/** Mask of zone bits that must be matched exactly. */
+#define ZONE_EF_MASK	0x7
+
+#define FRAME_TO_ZONE_FLAGS(ff)	\
+	((((ff) & FRAME_LOWMEM) ? ZONE_LOWMEM : \
+	    (((ff) & FRAME_HIGHMEM) ? ZONE_HIGHMEM : \
+	    ZONE_LOWMEM /* | ZONE_HIGHMEM */)) | \
+	    ZONE_AVAILABLE) 
+
+#define ZONE_FLAGS_MATCH(zf, f) \
+	(((((zf) & ZONE_EF_MASK)) == ((f) & ZONE_EF_MASK)) && \
+	    (((zf) & ~ZONE_EF_MASK) & (f)))
 
 typedef struct {
 	size_t refcount;      /**< Tracking of shared frames */
-	uint8_t buddy_order;  /**< Buddy system block order */
 	link_t buddy_link;    /**< Link to the next free block inside
                                    one order */
 	void *parent;         /**< If allocated by slab, this points there */
+	uint8_t buddy_order;  /**< Buddy system block order */
 } frame_t;
 
@@ -129,9 +148,4 @@
 }
 
-NO_TRACE static inline bool zone_flags_available(zone_flags_t flags)
-{
-	return ((flags & (ZONE_RESERVED | ZONE_FIRMWARE)) == 0);
-}
-
 #define IS_BUDDY_ORDER_OK(index, order) \
     ((~(((sysarg_t) -1) << (order)) & (index)) == 0)
@@ -146,4 +160,5 @@
 
 extern void frame_init(void);
+extern bool frame_adjust_zone_bounds(bool, uintptr_t *, size_t *);
 extern void *frame_alloc_generic(uint8_t, frame_flags_t, size_t *);
 extern void *frame_alloc(uint8_t, frame_flags_t);
@@ -161,4 +176,5 @@
 extern void frame_mark_unavailable(pfn_t, size_t);
 extern size_t zone_conf_size(size_t);
+extern pfn_t zone_external_conf_alloc(size_t);
 extern bool zone_merge(size_t, size_t);
 extern void zone_merge_all(void);
